/*jshint sub:true, esversion: 6*/

function getWeekdayFromNr( day, prefix, suffix ){
    prefix = prefix+" " || "";
    suffix = " "+suffix || "";
    if(day == 0){ return translator.get(prefix+"Sunday"+suffix); }
    else if(day == 1){ return translator.get(prefix+"Monday"+suffix); }
    else if(day == 2){ return translator.get(prefix+"Tuesday"+suffix); }
    else if(day == 3){ return translator.get(prefix+"Wednesday"+suffix); }
    else if(day == 4){ return translator.get(prefix+"Thursday"+suffix); }
    else if(day == 5){ return translator.get(prefix+"Friday"+suffix); }
    else if(day == 6){ return translator.get(prefix+"Saturday"+suffix); }
}
function toDateString( timestamp ){
    date = new Date( timestamp );
    now = Date.now();
  
    // If date is less than 10 seconds ago
    if(timestamp > now-10000){
      setTimeout(function(){ $(".now"+timestamp).html( toDateString( timestamp ) ); }, 10000);
      return "<span class='now"+timestamp+"'>"+translator.get("Now")+"</span>"; 
    }
    // If date is less than 1 minute ago
    else if(timestamp > now-60000){
      setTimeout(function(){ $(".then"+timestamp).html( toDateString( timestamp ) ); }, 60000);
      return "<span class='then"+timestamp+"'>"+translator.get("Less than a minute ago")+"</span>"; 
    }
    // If date is today
    else if(date.toDateString() == new Date().toDateString()){
      return translator.get("Today at")+" "+("0"+date.getHours()).slice(-2)+":"+("0"+date.getMinutes()).slice(-2);
    }
    // If date is the date of yesterday
    else if(date.toDateString() == new Date(now-24*60*60*1000).toDateString()){
      return translator.get("Yesterday at")+" "+("0"+date.getHours()).slice(-2)+":"+("0"+date.getMinutes()).slice(-2);
    }
    // If date is less than 7 days ago
    else if(timestamp > now-8*24*60*60*1000){
      return getWeekdayFromNr(date.getUTCDay(), "Last", "at")+" "+("0"+date.getHours()).slice(-2)+":"+("0"+date.getMinutes()).slice(-2);
    }
    else {
      return date.toDateString().replace(" "+new Date().getFullYear(),"")+" "+("0"+date.getHours()).slice(-2)+":"+("0"+date.getMinutes()).slice(-2);
    }
  
}
function checkAdmin(nuid){
  nuid = nuid || uid;
  if(groupData.creator == nuid || Object.keys(groupData.members).length == 1){
    return true;
  }
  else {
    return false;
  }
}


/*******************************/
/********* GROUP STUFF *********/
/*******************************/
var gviz = [], graphDetails = [], oldGraphDetails, databaseUrl;
// /** DEV **/var exampleNames = ["Peder Ås", "Marte Kirkerud", "Hans Lund", "Markus Kirkerud", "Ina Lund", "Knut Knutsen", "Morten Kirkerud", "Ingrid Ås"], nameI = -1;
// /** DEV **/exampleNames.sort(function(a, b){return 0.5 - Math.random();}); //randomize names
function groupScripts(){
  if(userData.groups){
    gviz = [];

    $("#group_viz_container").html("");
    if(currGroupID == ""){
      currGroupID = userData.groups[ Object.keys(userData.groups)[0] ].id;
    }

    firebaseListenersToStop.push('groups/'+currGroupID+"/"); //push ref here, so the listener is disabled on "loadScripts()"
    database.ref('groups/'+currGroupID+"/").off();
    database.ref('groups/'+currGroupID+"/").on('value', function(snapshot){
      console.log("new group data trigger!");
      groupData = snapshot.val();


      // If there are no members in the group - normally only first time after creation
      if(!groupData.members){

        // if(!(displayName = firebase.auth().currentUser.displayName)){
        //   if(!(displayName = firebase.auth().currentUser.email)){
        //     console.error("Couldn't determine username");
        //     alert("Couldn't determine username!");
        //     return false;
        //   }
        // }
        database.ref('groups/'+currGroupID+"/members/"+uid).update({ displayName: displayName, profileUrl: userPhotoURL, percent: (percent || 0) });
      }

      // UPDATE username or profileUrl if they are changed
      if(groupData.members[ uid ].displayName !== displayName || groupData.members[ uid ].profileUrl !== userPhotoURL){
        database.ref('groups/'+currGroupID+"/members/"+uid).update({ displayName: displayName, profileUrl: userPhotoURL }).then(function(){ console.log("Updated username or avatar"); });
      }

      // Update group-name in case it's changed
      if(groupData.name !== userData.groups[currGroupID].name){
        database.ref('users/'+uid+'/groups/'+currGroupID).update({name: groupData.name});

        $("#pageTitle").html(groupData.name);
        userData.groups[currGroupID].name = groupData.name;
        loadNavMenu();
      }

      // num = Object.keys( groupData.members ).length;
      num = 0;

      $.each(groupData.members, function( mid, value){
        graphDetails[num] = value;
        num++;
      });
      // if(isNumeric(Number(extraNum))){
      //   for(j=num;j<num+extraNum;j++){
      //     num++;
      //     graphDetails[j] = { percent: (Math.floor(Math.random()*10)), displayName: (exampleNames[j].split(" ")[0]) };
      //   }
      // }

      // GENERATE KEY: database.ref("groups/").push().key

      // var num = num || 4;


      var newNum = num;
      if(num % 3 == 0 || num >= 5){
        newNum = 3;
      }
      else if(num % 2 == 0){
        newNum = 2;
      }
      vizHeight = ($(window).width()-80 )/newNum;
      if(vizHeight > 200){ vizHeight = 200; }

      vizRadius = (vizHeight-10)/2/1.25;
      vizFontSize = vizHeight/6;
      $("#slick_container").width(vizHeight*newNum);
      // $("#group_viz_container").css({'height': vizRadius*2+"px"}); //, 'padding-top': (50-vizHeight/4 > 0?50-vizHeight/4:50)+'px'
      // vizRadius = 50;  vizHeight = 200;  vizFontSize = 25; // three graphs
      //for each user in this group
      for(i=0;i<=num-1;i++){
        if(!gviz[i]){
          if(i % newNum == 0){ $("#group_viz_container").append("<div class='gTableRow' style='display: table-row'>"); }
          $("#group_viz_container div.gTableRow").last().append("<div id='gviz"+i+"' style='display: table-cell;'>");
          gviz[i] = vizuly.viz.radial_progress( document.getElementById("gviz"+i) );

          gviz[i].data( (graphDetails[i].percent || 0) ).height(vizHeight).width(vizHeight).radius(vizRadius).min(0).max(100).capRadius(1).startAngle(201).endAngle(200).arcThickness(0.12)
          .label(function(d,i){ return d3.format(".1f")(d); }).update();

          $("#gviz"+i+" .vz-radial_progress-label-plot text").css('font-size',vizFontSize+'px').attr('y',(vizHeight/2)-(vizFontSize/4));
          $("#gviz"+i+" .vizuly").css('margin','0 -100px');
          // $("#gviz"+i).append("<div style='display: table-caption; text-align: center;'>"+exampleNames[i]+"</div>");
          // /** DEV **/if(!exampleNames[nameI+1]){ nameI = -1; } nameI++;
          // $("#gviz"+i).append("<div>"+exampleNames[nameI].split(" ")[0]+"</div>");
          shortName = graphDetails[i].displayName;
          shortName = shortName.split("@")[0];
          shortName = shortName.split(" ")[0];
          $("#gviz"+i).append("<div>"+shortName+"</div>");
        }
        else if(graphDetails[i].percent != gviz[i].data()){
          gviz[i].data((graphDetails[i].percent || 0)).update();
        }
      }

      if(Object.keys( groupData.members ).length <= 1){
        $("#groupNoMembers").show();
        $("#groupNoPost").hide();
      }

    });

    $("#groupSlide").slick({
      arrows: false,
      infinite: false,
      touchThreshold: 10,
      draggable: false
    });


    var groupFeedSel = "";
    $(".groupFeedMenu div").unbind().on('click', function(e){
      if($(this).attr('id') != groupFeedSel){
        groupFeedSel = $(this).attr('id');
        // $(".groupFeedMenu div").css("border-bottom", "");
        // $(this).css("border-bottom","solid 3px #1223ff");
        $("#groupNoPost").hide();
        $(".writingUserPostWrapper").fadeIn();
        if($(this).attr('id') == "groupPosts"){
          // $(".postType:nth-child(-n+3)").slideDown();
          // $(".postType:nth-child(n+3)").show();

          // $(".progType:nth-child(-n+3)").slideDown();
          // $(".progType:nth-child(n+3)").show();

          $(".slideHR").css("margin-left","0%");
          $("#groupSlide").slick('slickGoTo', 0);
          
          if($(".postType").length + $(".progType").length == 0 && $("#groupNoMembers").css("display") == "none"){
            $("#groupNoPost").show();
          }
        }
        /*else if($(this).attr('id') == "groupPosts"){

          $(".slideHR").css("margin-left","33%");
          if($(".postType").length == 0){
            $("#groupNoPost").show();
          }
        }
        else if($(this).attr('id') == "groupProg"){
          
          $(".writingUserPostWrapper").fadeOut();
          $(".slideHR").css("margin-left","66%");

          if($(".progType").length == 0){
            $("#groupNoPost").show();
          }
        }*/
        else if($(this).attr('id') == "groupChpt"){
          
          // $(".writingUserPostWrapper").fadeOut();
          $(".slideHR").css("margin-left","50%");
          $("#groupSlide").slick('slickGoTo', 1);
          fetchDatabase(currGroupID, "group");

          // if($(".progType").length == 0){
            // $("#groupNoPost").show();
          // }
        }
      }
    });

    $("#groupPostForm textarea").keypress(function(e){
      if(e.which == 13 && !e.shiftKey){ $("#groupPostForm").submit(); }
    });
    $("#groupPostForm").on('submit',function(e){
      e.preventDefault();
      reading = "";
      if(userData.plans && userData.plans[0].cursor){
        $.each(userData.plans[0].cursor, function(key, value){
          // reading = books[bothString][key]+" "+value;
          reading = key+"-"+value;
          return;
        });
      }
      createPost($("#groupPostForm textarea").val(), reading);
    });

    database.ref('groups/'+currGroupID+"/posts").once('value').then(function(snapshot){
      postData = snapshot.val();

      $.each(postData,function(key,value){
        insertPost(value, key);
      });

    });
  }
  else {
    alert("You are not in any groups.");
  }
}
function insertPost(postData, postKey){
  newBody = postData.body;

  $("#groupNoPost").hide(); // Hide the "no-post"-post

  //INSERT LIST
  if(newBody.includes("\n*")){
    temp = newBody.split("\n*");
    newBody = temp[0] + "<ul>";
    for(i=1;i<temp.length;i++){
      if(i != temp.length-1){
        newBody += "<li>"+temp[i]+"</li>";
      }
      else {
        //last key
        if(temp[i].includes("\n")){
          temp1 = temp[i].split("\n",2);
          newBody += "<li>"+temp1[0]+"</li></ul>"+temp1[1];
        }
        else {
          newBody += "<li>"+temp[i]+"</li>";
        }
      }
    }
  }

  //INSERT LINE-BREAKS
  newBody = newBody.replace(/\n/g,"<br>");

  // Insert profile-picture
  try{
    temp = groupData.members[postData.author].profileUrl;
    if(temp.indexOf("libravatar") > 0 && temp.indexOf("?") < 0){ avatarUrl = temp+"?d=https://www.bibleplan.no/img/defaultprofile.svg"; }
    else { avatarUrl = temp; }
    postAuthorName = groupData.members[postData.author].displayName;
    // }
  }
  catch(err){
    avatarUrl = "img/defaultprofile.svg";
    postAuthorName = postData.authorName || "&lt;Member left&gt;";
    // console.log(err);
  }

  // Textify postData.reading
  readPos = "";
  if(postData.reading){
    if((readSpl = postData.reading.split("-")).length == 2){
      readPos = translator.get(books[bothString][readSpl[0]].name)+" "+readSpl[1];
    }
  }

  // If post was just created, just set date as NOW
  if(!isNumeric( postData.timestamp )){ postData.timestamp = Date.now(); }

  html = "<div id='post"+postKey+"' class='userPostWrapper "+(postData.type == "prog"?"prog":"post")+"Type'>\n";
  html += "  <div class='userPhoto' style='background: url(\""+avatarUrl+"\");background-size: cover;background-position: center;'></div>\n";
  html += "  <h3 class='userName'>"+postAuthorName+"</h3>\n";
  html += "  <p class='currentBookChapter'>"+readPos+(readPos.length > 0?" · ":"");
  html += "<span title='"+new Date(postData.timestamp).toUTCString()+"'>"+toDateString( postData.timestamp )+"</span>";
  html += "</p>\n";
  html += "  <div class='post'>"+newBody+"</div>\n";
  html += "</div>";

  // $(".writingUserPostWrapper").after(html);
  $(html).hide().insertAfter(".writingUserPostWrapper").fadeIn(500);
}

function joinGroup( gid ){
  // if(!(displayName = firebase.auth().currentUser.displayName)){
  //   if(!(displayName = firebase.auth().currentUser.email)){
  //     console.error("Couldn't determine username");
  //     alert("Couldn't determine username!");
  //     return false;
  //   }
  // }
  database.ref("/groups/"+gid).once("value").then(function(snapshot){
    if(!snapshot.exists()){
      console.error("Group not found!");
      alert(translator.get("Something went wrong. Maybe the group was deleted?"));
      return;
    }
    
    jGroupData = snapshot.val();

    if(jGroupData.privacy == "closed"){
      alert(translator.get("The group you are trying to join is closed to new members."));
      return;
    }

    if(jGroupData.members[uid]){
      alert(translator.get("You are already in this group!"));
      return;
    }

    database.ref("groups/"+gid+"/members/"+uid).update({ profileUrl: userPhotoURL, displayName: displayName, percent: 0 }).then(function(){
      console.log("successfully joined a group");
      database.ref("users/"+uid+"/groups/"+gid+"/").set({id: gid, name: jGroupData.name}).then(function(){

        
        //JOIN THE READING PLAN
        console.log("trying to join groups plan...");
        database.ref("groups/"+gid).once("value").then(function(snapshot){
          console.log("trying to join groups plan... (2)");
          if( snapshot.hasChild("plan/0") ){
            joinPlan = snapshot.val().plan[0];
            database.ref("users/"+uid+"/plans/"+gid+"/").set(joinPlan);
            console.info("Joined the groups plan:",joinPlan);
          }
        }).catch(function(error){ console.error( error ); });
      });
        
      if(!userData.groups){ userData.groups = {}; }
      userData.groups[gid] = {id: gid, name: jGroupData.name}; //hack to have it appear immediately
      loadNavMenu();

      currGroupID = gid;
      loadPage("group.html", jGroupData.name);
    });
  });
}
function leaveGroup(gid){
  database.ref("/groups/"+gid).once("value").then(function(snapshot){
    if(!snapshot.exists()){
      console.error("GROUP NOT FOUND");
      alert(translator.get("Something went wrong. Please try again!"));
      return;
    }

    gData = snapshot.val();

    if(uid == gData.creator || Object.keys(gData.members).length == 1){
      console.warn("Delete group-function is not yet available!");
      alert("'Delete group'-function is not yet available!");
      return;
    }
    database.ref('groups/'+gid+"/").off();

    loadPage(startPage);
    database.ref("/groups/"+gid+"/members/"+uid).set({});
    database.ref("/users/"+uid+"/groups/"+gid).set({});
    console.log("You left the group!");
    alert(translator.get("You succesfully left the group!"));
    
    delete userData.groups[gid];
    currGroupID = "";
    loadNavMenu();
  });
}
function createGroup(input){
  if(input.creator == uid && input.name != ""){
    var groupName = input.name;
    var newID = database.ref("groups/").push(input).key;
    database.ref("users/"+uid+"/groups/"+newID+"/").set({id: newID, name: groupName}).then(function(){
      console.log("Created new group:",newID,input);

      //hack to have it appear immediately:
      if(!userData.groups){ userData.groups = {}; }
      userData.groups[newID] = {id: newID, name: groupName};
      loadNavMenu();

      currGroupID = newID;
      loadPage("group.html", groupName);
    });
  }
  else {
    console.warn("Failed to create group. Check that you're logged in and/or put in a name!");
    alert(translator.get("Failed to create group. Check that you're logged in and/or put in a name!"));
  }
}
function createGroupLink(gID, expire){
  if(!checkAdmin(uid)){
    console.log("Sorry, but you are not allowed to do that!");
    return false;
  }

  expire = expire || 0;
  randomLink = btoa(Math.random()*100).substring(0,8);
  
  if(groupData.privacy == "closed"){

    deviceConfirm(translator.get("Your groups privacy is currently set to 'closed'. Do you want to set it to 'invite-only'?"), 
    "Yes", function(){
      database.ref("groups/"+currGroupID+"/").update({ privacy: "invite" }).then(function(){ console.log("Updated privacy"); updateGroupData(function(){ createGroupLink(gID, expire); }); });
    });

    return false;
  }

  database.ref("links/"+randomLink).set({ linkID: randomLink, group: gID, expire: expire, created: Date.now(), name: groupData.name }).then(function() {
    database.ref("groups/"+gID+"/invites/"+randomLink).update({ link: randomLink, creator: displayName });
    console.log('Link created succesfully:', randomLink);
    // alert( "Link created succesfully!\nJoin code: "+randomLink );
    if(currentPage == "group_members.html"){
      openInvites();
    }

    // alert( "https://www.bibleplan.no/joinGroup.php?join="+randomLink );

    /*
    Creating FIREBASE Direct Links
    longLink = { 
      "longDynamicLink": encodeURI("https://group.bibleplan.no/?link=https://www.bibleplan.no/group/MC4wMzcy&apn=no.bibleplan.bibleplan&isi=1451024415&ibi=no.bibleplan.bibleplan")
    };
    
    $.ajax({
      method: "POST",
      url: "https://firebasedynamiclinks.googleapis.com/v1/shortLinks?key=AIzaSyBDVwQqOrvblDF9F1wCqmmnatS4QP0xJlE",
      data: longLink
    })
    .done(function( msg ) {
      console.log( msg );
    });
    */


  })
  .catch(function(error) {
    console.log('Oops, failed', error);
    alert("Oops, an error occured. Please try again!");
  });
}
function createPost(body, reading, gID){
  reading = reading || "";
  gID = gID || currGroupID || "";
  if(body.length >= 5 && body.length <= 1000 && gID != ""){
    postData = {
      author: uid,
      authorName: (displayName || ""),
      reading: reading,
      body: $(".writePost").val(),
      timestamp: firebase.database.ServerValue.TIMESTAMP
    };
    if((postKey = database.ref("groups/"+gID+"/posts").push(postData).key) !== false){
      insertPost(postData, postKey);
      $(".writePost").val("").blur();
    }
  }
  else {
    console.log("not posted");
  }
}




/********************************/
/****** CREATE GROUP STUFF ******/
/********************************/
function createGroupScripts(){
  console.log("Loading CREATE GROUP scripts!");
  let newGroup = {};
  // newGroup.plan = [{}];
  newGroup.creator = uid;
  // newGroup.style
  // newGroup.plan
  
  // Add sliding function 
  /* $("#wrapper-frontpage").slick({
    accessibility: false,
    arrows: false,
    infinite: false,
    touchThreshold: 10,
    draggable: false
  });

  // Make "next" buttons to go to next slide
  $(".nextSlide").unbind().click(function(event){ event.preventDefault(); if(!$(this).hasClass("arange_inactive")){ $("#wrapper-frontpage").slick('slickNext'); } });
 /* */
  // Name your group
  $("#nGroupName").on("keyup",function(e){
    if((newGroup.name = $("#nGroupName").val()) != false){
      $("#groupNameNext").removeClass("arange_inactive");
      // if(e.which == 13){ $("#wrapper-frontpage").slick('slickNext'); }
    }
    else {
      $("#groupNameNext").addClass("arange_inactive");
    }
  });
  //Privacy : #gIsPrivate


  // Choose group-style
  /*$(".gStyle").on('change', function(){
    if( $("input:checked.gStyle").val() == "gStyleDiff"){
      $("#newSetupBook").hide();
      $("#newSetupReadMuliplePlaces").hide();
      $("#newSetupPlan").hide();
      // $("#newSetupNotif").hide();
      newGroup.plan[0].style = "free";
    }
    else {
      $("#newSetupBook").show();
      $("#newSetupReadMuliplePlaces").show();
      $("#newSetupPlan").show();
      $("#newSetupNotif").show();
      newGroup.plan[0].style = "strict";
    }

    $("#groupTypeNext").removeClass("arange_inactive");
  });


  // Setup books
  var booksHtml = '<ul class="menu menuChecklist">\n';
  var bookCount = 0;
  for(;books[bothString];){
    if( typeof books[bothString][ bookCount ] !== 'undefined'){
      var thisBook = books[bothString][ bookCount ];
      booksHtml += '<li id="li'+bookCount+'"><label><a class="menutext menutextCheckmark"><input class="myinput bright checkboxListmenu" type="checkbox" checked="checked" id="sel'+bookCount+'" name="'+bookCount+'" /><input style="display: none;" type="checkbox" class="myinput bright focusBook" id="focus'+bookCount+'" name="'+bookCount+'">'+translator.get( thisBook.name )+'</a></label></li>';
      bookCount++;
    }
    else {
      break;
    }
  }
  booksHtml += '</ul>\n';
  $("#setupBooks").html(booksHtml);

  $(".selList").unbind().click(function(event){
    event.preventDefault();

    if($(this).attr('id') == "selAll"){ $(".checkboxListmenu").each(function(value, key){ $("#sel"+value).prop("checked",true); }); }
    else if($(this).attr('id') == "selNone"){ $(".checkboxListmenu").each(function(value, key){ $("#sel"+value).prop("checked",false); }); }
    else if($(this).attr('id') == "selNT"){
      $(".checkboxListmenu").each(function(value, key){
        if(value < 39){ $("#sel"+value).prop("checked",false); }
        else { $("#sel"+value).prop("checked",true); }
      });
    }
    else if($(this).attr('id') == "selOT"){
      $(".checkboxListmenu").each(function(value, key){
        if(value < 39){ $("#sel"+value).prop("checked",true); }
        else { $("#sel"+value).prop("checked",false); }
      });
    }
  });

  $("input[name=focusOn]").on('change', function(){
    if( $(this).val() == "doFocus" ){
      $(".focusBook").show();
    }
    else {
      $(".focusBook").hide();
    }
  });
  $(".checkboxListmenu, .selList").on('click',function(){
    $(".chStart").prop("checked",false);
    $("#chStartSelect").hide();
    $("#chStartContinue").addClass("arange_inactive");
  });

  // Choose start
  newGroup.plan[0].cursor = { 0: { 0: -1 } }; //default
  $(".chStart").on('change', function(){
    if( $("input:checked.chStart").val() == "yes" ){
      $("#chStartSelect").show();
      $("#chStartContinue").addClass("arange_inactive");

      listElemHTML = "";
      $("input:checked.checkboxListmenu").each(function(key, value){
        bookListId = Number($(value).attr('id').slice(3));
        listElemHTML += "<option value='"+bookListId+"'>"+translator.get(books[bothString][bookListId].name)+"</option> ";
      });
      $(".chStartList").each(function(index){
        if($(this).attr("id")=="drop1"){ $(this).html(listElemHTML); }
        else {
          $(this).html("<option>--</option>"+listElemHTML);
        }
        $(this).on('change', function(){
          if($(this).val()){
            newGroup.plan[0].cursor[index] = [];
            newGroup.plan[0].cursor[index][$(this).val()] = -1;
            $("#chStartContinue").removeClass("arange_inactive");
          }
        });
      });
    }
    else {
      $("#chStartSelect").hide();
      $("#chStartContinue").removeClass("arange_inactive");
      newGroup.plan[0].cursor = { 0: { 0: -1 } }; //default
    }
  });

  
  // Reading method
  $(".pMethod").on('change', function(){
    if( $("input:checked.pMethod").val() == "methodDaily" ){
      $("#methodPlan-wrapper").hide();   $("#methodDaily-wrapper").show();
      // newplanSetup.plan.method = "daily";
      newGroup.plan[0].method = "daily";
      newGroup.plan[0].daily = Number($("#dailyChapters").val());
    }
    else if( $("input:checked.pMethod").val() == "methodPlan" ){
      $("#methodDaily-wrapper").hide();  $("#methodPlan-wrapper").show();
      // newplanSetup.plan.method = "plan";
      newGroup.plan[0].method = "plan";
      // newGroup.plan[0].length = 180; //DEFAULT
    }
    else if( $("input:checked.pMethod").val() == "methodFree" ){
      $("#methodDaily-wrapper").hide();  $("#methodPlan-wrapper").hide();
      // newplanSetup.plan.method = "free";
      newGroup.plan[0].method = "free";
    }
    // ENABLE BUTTONS
    $("#groupStyleNext").removeClass("arange_inactive");
    // $(".newplanSubmit").removeClass("arange_inactive");
    // $("#fourthSlideSkip").css("color","rgb(24, 8, 255)");
  });

  // DAILY CHAPTERS
  // $("#dailyChapters").val(newplanSetup.plan.daily);
  $("#dailyChapters").val(newGroup.plan[0].daily);
  $("#dailyChapters").on('change', function(){
    // newplanSetup.plan.daily = Number( $( this ).val() );
    newGroup.plan[0].daily = Number( $( this ).val() );
  });

  // FOLLOWING PLAN
  planStart = new Date();
  planEnd = new Date( planStart );
  // planEnd.setDate(planStart.getDate() + newplanSetup.plan.length);
  planEnd.setDate(planStart.getDate() + 180); //DEFAULT
  $("#planStart").val( planStart.toISOString().substr(0, 10) );  // start day
  $( "#planEnd" ).val( planEnd.toISOString().substr(0, 10) );    // end day
  // $("#planDynLength").html( translator.get("Plan length")+": "+newplanSetup.plan.length );
  $("#planDynLength").html( translator.get("Plan length")+": "+newGroup.plan[0].length );

  // newplanSetup.plan.start = new Date( $("#planStart").val() ).getTime();
  newGroup.plan[0].start = new Date( $("#planStart").val() ).getTime();

  // UPDATE START DATE
  $("#planStart").on('change', function(){
    planStart = new Date( $( this ).val() );
    // newplanSetup.plan.start = planStart.getTime();
    newGroup.plan[0].start = planStart.getTime();

    var newEnd = new Date( $("#planEnd").val() );
    var newEnd1 = Number(((newEnd - planStart) / (1000*60*60*24)).toFixed(0));

    $("#planDynLength").html( translator.get("Plan length")+": "+ newEnd1 );

    if( newEnd1 < 400 && newEnd1 > 0 ){
      // newplanSetup.plan.length = newEnd1;
      newGroup.plan[0].length = newEnd1;
      $("#planDynLength").css("color","");
    }
    else {
      $("#planDynLength").css("color","#ff384d");
    }
  });

  // UPDATE PLAN LENGTH via end date
  $("#planEnd").on('change', function(){
    var newEnd = new Date( $( this ).val() );
    var newEnd1 = Number(((newEnd - planStart) / (1000*60*60*24)).toFixed(0));

    $("#planDynLength").html( translator.get("Plan length")+": "+ newEnd1 );

    if( newEnd1 < 400 && newEnd1 > 0 ){
      // newplanSetup.plan.length = newEnd1;
      newGroup.plan[0].length = newEnd1;
      $("#planDynLength").css("color","");
    }
    else {
      $("#planDynLength").css("color","#ff384d");
    }
  });


  // Weekdays
  // weekdays = newplanSetup.plan.weekdays.split("");
  try{
    weekdays = newGroup.plan[0].weekdays.split("");
  }
  catch(err){
    weekdays = ["0","1","2","3","4"];
  }

  $("#weekday div").removeClass("weekdaySelected");
  $.each( weekdays, function( index, value ){
    weekday = value.toString();
    $("#weekday div#"+weekday).addClass("weekdaySelected");
  });

  $("#weekday div").on('click', function(){
    toggleThis = $( this ).attr('id').toString();
    if( weekdays.indexOf( toggleThis ) >= 0){
      if(weekdays.length > 1){
        key = weekdays.indexOf( toggleThis );
        weekdays.splice( key, 1 );
        newWeekdays = weekdays.join("");
        $(this).removeClass("weekdaySelected");
      }
    }
    else {
      weekdays.push( toggleThis );
      newWeekdays = weekdays.join("");
      $(this).addClass("weekdaySelected");
    }
    // newplanSetup.plan.weekdays = newWeekdays;
    newGroup.plan[0].weekdays = newWeekdays;
  });
  /*******/


  /** DO THE MAGIC **/
  $("#groupNameNext").unbind().click(function(e){
    e.preventDefault();
  // $(".lastSlide").click(function(){
  // $(".nextSlide").click(function(){
    newGroup.privacy = ($("input:checked#gIsPrivate").val() === "1")?"closed":"open";
    
    //[WIP] forsøk på å komprimere lista.
    /*doRead = [];
    doFocus = [];
    $("#setupBooks input").each(function(){
      if($(this).is(":checked")){
        if($(this).hasClass("focusBook")){
          doFocus.push(Number($(this).attr("name")));
        }
        else {
          doRead.push(Number($(this).attr("name")));
        }
      }
    });
    // console.log(doRead, doFocus);

    newGroup.plan[0].log = { 0: { 0: 'log' } };
    newGroup.plan[0].plan = "group";
    newGroup.plan[0].books = numArrtoString(doRead);
    if($("input[name=focusOn]:checked").val() == "doFocus"){
      newGroup.plan[0].focus = numArrtoString(doFocus);
    }
    
    */
    createGroup(newGroup);
  });
}
function numArrtoString( arr ){
  str = "";
  for(i = 0; i < arr.length; i++){
    if(i == 0){
      str += arr[i];
    }
    else if(arr[i] == arr[i-1]+1 && arr[i] != arr[i+1]-1){
      str += "-"+arr[i];
    }
    else if(arr[i] != arr[i-1]+1){
      str += ","+arr[i];
    }
  }

  return str;
}
function numStrtoArr( str ){
  
  arr = [];
  blocks = str.split(",");
  for(i=0; i<blocks.length; i++){ //BLOCKS
    values = blocks[i].split("-");
    if(values.length == 2){
      for(j=Number(values[0]);j<=Number(values[1]);j++){
        arr.push(j);
      }
    }
    else {
      arr.push( Number(blocks[i]) );
    }
  }

  return arr;
}




/********************************/
/******** GROUP SETTINGS ********/
/********************************/
function groupSettingsScripts(){
  console.log("Loading group settings");

  // Check if a group is selected
  if(typeof groupData == "undefined"){
    console.warn("You are not in a group. Going back to startpage!");
    loadPage(startPage);
    return;
  }

  // GROUP INVITES
  // if(checkAdmin()){
    // $("#groupInvLink a").unbind().click(function(e){
      // e.preventDefault();
      // openInvites();
    // });
  // }

  // LEAVE/DELETE GROUP
  $("#leaveGroupLink a").attr("href","#leaveGroup").html(translator.get("Leave group"));
  if(groupData.creator == uid || Object.keys(groupData.members).length == 1){
    $("#leaveGroupLink a").attr("href","#deleteGroup").html(translator.get("Delete group"));
  }

  $("#leaveGroupLink a").unbind().click(function(e){
    e.preventDefault();

    if($(this).attr("href") == "#leaveGroup"){
      deviceConfirm("Are you sure you want to leave this reading group?","Yes",function(){ leaveGroup( currGroupID ); });
    }
    else if($(this).attr("href") == "#deleteGroup"){
      alert("Coming soon!");
    }
  });
}
function openInvites(){
  updateGroupData(function(){

    
    html = "";
    html += "<div id='inviteBox'>";
    html += "<h3>"+translator.get("Invite People")+"</h3>";
    
    if(groupData.invites){
      
      html += "<ul style='padding: 0;'>";
      html += "<li>"+translator.get("Send this link to the people you want to invite.")+"</li>";
      for(const x in groupData.invites){
        html += "<li style='background: #e0e0e0;display: table;margin: 25px auto 15px auto;padding-left: 10px;border-radius: 5px;font-size: 26px;color: #545454;'><input type='text' val='"+x+"' value='"+x+"' id='copy"+insertNum()+"' class='disabled' style='pointer-events: none; width: 100px;height: 30px;margin: unset;float: unset;font-size: 19px;border: 0;vertical-align: middle;text-align: center;background-color: #e0e0e0;' />";
        html += "<button class='tinyBluelueButton copySomething' style='float:right; margin-top: 0px;margin-bottom: 1px; margin-left: 10px;'>"+translator.get("Copy Link")+"</button></li>"+((temp = groupData.invites[x].clicks)?"| Joins: "+temp:"")+"</li>";
        html += "<li style='margin: 15px auto 35px'><button class='tiny deleteLnk' style='width:90%; max-width: 277px;'>"+translator.get("Delete Invite Link")+"</button></li>";
      }
      html += "</ul>";
      html += "<button id='closePopup'>Done</button>";
      
    }
    else {
      html += "<ul style='padding: 0;'>";
      html += "<li>"+translator.get("There are currently no invites for this group.")+"</li>";
      html += "</ul>";
      if(checkAdmin(uid)){ html += "<button class='createInvite'>"+translator.get("Create an invite")+"</button>"; }
      else { html += "<button id='closePopup'>Done</button>"; }
    }
    
    html += "</div>";
    
    // console.log("Open INVITES! pleease!");
    
    setTimeout( function(){ 
      if($(".popupelem").length == 1){
        $(".popupelem").html( html );
      }
      else {
        createPopup( html );
      }
      // createPopup( html );
      // $("#pageblur").html("<div id='popup'>"+html+"</div>");
      // setTimeout(function(){ showPopup(); },15); ///Timeout here to allow it to work, I guess...
      $(".copySomething").click(function(){
        copyInput = $(this).parent().children("input");
        if(!navigator.clipboard){
          copyInput.val( copyInput.attr("val") );
          
          copyThis1 = document.getElementById( copyInput.attr("id") );
          copyThis1.select();
          copyThis1.setSelectionRange(0,99999);
          document.execCommand("copy");
          console.log("copied - fallback");
          $("#inviteBox").click();
        }
        else {
          navigator.clipboard.writeText( copyInput.attr("val") ).then(function() {
            console.log('Async: Copying to clipboard was successful!');
          }, function(err) {
            console.error('Async: Could not copy text: ', err);
          });
        }
      });
      $(".deleteLnk").on('click', function(){
        alert("Coming soon!");
      });
      $(".createInvite").one('click', function(){
        createGroupLink(currGroupID);
        // closePopup();
      });
      $("#closePopup").click(function(){ closePopup(); });
    }, 15);
  });
}
function updateGroupData( func ){
  database.ref('groups/'+currGroupID+"/").once('value').then(function(snapshot){
    groupData = snapshot.val();
    console.log("Refresh groupData");

    if(typeof func != "undefined"){
      func();
    }
  });
}




/*******************************/
/******** GROUP MEMBERS ********/
/*******************************/
function groupMembersScripts(){
  console.log("Loading group-members-scripts!");

  if(typeof groupData == "undefined"){
    console.warn("You are not in a group. Going back to startpage!");
    loadPage(startPage);
    return;
  }

  $("#openInvites").unbind().click(function(e){
    e.preventDefault();
    openInvites();
  });

  $("#memberList").html("");
  for(const key in groupData.members){
    if(groupData.members.hasOwnProperty(key)){
      const element = groupData.members[key];
      console.log("member:",element);

      try{
        temp = groupData.members[key].profileUrl;
        if(temp.indexOf("libravatar") > 0 && temp.indexOf("?") < 0){ profilePicture = temp+"?d=https://www.bibleplan.no/img/defaultprofile.svg"; }
        else { profilePicture = temp; }
      }
      catch(err){
        profilePicture = "/img/defaultprofile.svg";
      }

      usrName = groupData.members[key].displayName;

      html = "";
      html += "<li><div class='grid-container-member-menu-tree'>";
      html += "<div class='grid-item followListPhoto'><img class='userPhoto' src='"+profilePicture+"' alt='Profile Picture'></div>";
      html += "<div class='grid-item'><a class='menutext_no_arrow_no-border'>"+usrName+"</a></div>";
      
      if(groupData.creator == uid && key != groupData.creator){
        html += "<div class='grid-item'><button id='"+key+"' class='kickUser button tiny'>kick</button></div>";
      }
      $("#memberList").append(html);
    }  }

  if(groupData.creator == uid){
    $(".kickUser").click(function(){
      deviceConfirm("Are you sure you want to kick this member?", "Yes", function(){ alert("Coming soon!\nContact developers if its urgent!"); });
    });
  }
}

// GROUP INFO
function groupInfoScripts(){
  console.log("Loading group info scripts!");

  //INSERT Info
  $("#groupName").html(groupData.name);
  $("#groupDescr").html( groupData.descr || translator.get("This group has no description yet."));

  //EDIT Info
  if(checkAdmin(uid)){
    $(".editInfoBtn").click(function(){
      console.log("Open group info edit");

      //translate inputs
      $("#closeGrEdBtn").val( translator.get("Done") );
      $("#groupEditForm input[name=groupName]").attr("placeholder","* "+translator.get("Group Name")).val(groupData.name);
      $("#groupEditForm textarea").attr("placeholder",translator.get("Description")).val(groupData.descr || "");

      $(".groupInfoPopupText").addClass("showGroupInfo");
      if($.inArray("win", $("html").attr("class").split(" ") ) != -1 || $.inArray("android", $("html").attr("class").split(" ") ) != -1){
        $(".close").css({"float": "right", "margin-bottom": "0px"});
      }

      $(".groupInfoPopupBox").click(function(e){
        e.stopPropagation();
      });

      $("#groupEditForm").on('submit', function(e){
        e.preventDefault();

        newName = $("#groupEditForm input[name=groupName]").val();
        newDescr = $("#groupEditForm textarea").val();
        if(newName != ""){
          database.ref("groups/"+currGroupID+"/").update({ name:  newName, descr: newDescr })
            .catch(function(err){
              console.log(err);
              alert("Something went wrong!");
            })
            .then(function(){
              $(".groupInfoPopupText").removeClass("showGroupInfo");
              groupData.name = newName;
              groupData.descr = newDescr;

              $("#groupName").html(groupData.name);
              $("#groupDescr").html( groupData.descr);
            });
          
          
        }
        else {
          alert("The group need a name! Please enter one!");
        }
      });
      $(".groupInfoPopup, .close").one('click',function(){
        $(".groupInfoPopupText").removeClass("showGroupInfo");
      });
    });
  }
  else {
    $(".editInfoBtn").hide();
  }

}