/********************************/
/******** SETTINGS STUFF ********/
/********************************/
function settingsScripts( planNr ){
    console.log("Loading SETTINGS scripts!");
    planNr = planNr || 0;
  
    //SET HEADLINE
    if(userData.plans){
      if(userData.plans[ planNr ].method == "plan"){
        if(typeof remainingDays != "undefined"){
          $("#planLength").html( remainingDays );
          $("#planLengthText").show();
        }
        else {
          $("#planLength").html(translator.get("Plan finished"));
          $("#planLengthText").hide();
        }
      }
      else if(userData.plans[ planNr ].method == "daily"){
        if(typeof estRemainingDays != "undefined"){
          $("#planLength").html( estRemainingDays );
          $("#planLengthText").show().html("Est "+translator.get("Days left").toLowerCase());
        }
        else {
          $("#planLength").html("-");
          $("#planLengthText").show();
        }
      }
      else if(userData.plans[ planNr ].method == "free"){
        $("#planLength").html( percent.toFixed(2)+"%" );
        $("#planLengthText").hide();
      }
    }
    else {
      $("#daycounter-wrapper").hide();
    }
  
    // SHOW REGISTER if user isn't registered
    if(!uid || isAnon){
      $("#signup-menu").html( translator.get("Register") );
    }

    /** DEV **/ if(appVersion.substr(0,1) == "d"){ $("#settingsDevOptions").show(); $(".deleteAccButton").show().click(function(e){ e.preventDefault(); deviceConfirm(translator.get("Are you sure you want to delete your account?"), "Yes", function(){ deleteUserAndLog(); }); }); }

    // SWITCH BETWEEN PLAN SETTINGS AND USER SETTINGS
    // $("#login-under-menu-wrapper div").unbind().click(function(event){
    $(".clickMenu").unbind().click(function(event){
      // event.preventDefault();

      click = $( this ).attr("href");
      if( click == "#planSettings"){
        $("#userRegisterSettings").hide();  $("#userSettings").hide();
        $("#signup-menu").css({"border-bottom": "", "color": "rgba(255, 255, 255, 0.58)"});

        $("#planSettings").show();
        $("#login-menu").css({'border-bottom': "solid 3px #fff","color": "#fff"});
      }
      else if( click == "#userSettings" ){
        // if(isAnon || !uid){
          // loadPage("login.html","Login");
        // }
        // else {
          $("#planSettings").hide();
          $("#login-menu").css({"border-bottom": "", "color": "rgba(255, 255, 255, 0.58)"});
  
          if($("#signup-menu").html() == translator.get("Register")){ $("#userRegisterSettings").show(); }
          else { $("#userSettings").show(); }
          $("#signup-menu").css({'border-bottom': "solid 3px #fff", "color": "#fff"});
        // }
      }
    });
  
    // TRANSLATING
    $("#user_name").attr("placeholder",translator.get("Your name"));
    $("#user_email").attr("placeholder",translator.get("Email"));
    $("#change_pwd_old").attr("placeholder",translator.get("Old password"));
    $("#change_pwd_new").attr("placeholder",translator.get("New password"));
    $("#change_pwd_new1").attr("placeholder",translator.get("Repeat new password"));
    $("#change_pwd").attr("value",translator.get("Change Password"));
    // TRANSLATING REGISTER
    $("#register_usr_email").attr("placeholder",translator.get("Email"));
    $("#register_pwd").attr("placeholder",translator.get("Password"));
    $("#register_submit").val(translator.get("Register"));
    $("#setupCreateTOS").html(
      $("#setupCreateTOS").html()
       .replace("I have read and accept the", translator.get("I have read and accept the"))
       .replace("Terms of Service", translator.get("Terms of Service"))
    );
    $("#accTrn").html( translator.get("Do you already have an account?")+" <a id='accLgn' href='#login' style='color: #1808ff'>"+translator.get("Log in here!") );
    $("#accLgn").click(function(e){
      e.preventDefault();
      loadPage("login.html", "Login");
    });

    if(uid){
      if(userPhotoURL){
        if(userPhotoURL.indexOf("libravatar") > 0 && userPhotoURL.indexOf("?") < 0){ avatarUrl = userPhotoURL+"?s=50&d=https://www.bibleplan.no/img/defaultprofile.svg"; }
        else { avatarUrl = userPhotoURL; }
      }
      else { avatarUrl = "img/defaultprofile.svg"; }
      
      $("#user_photo").attr("src", avatarUrl);
      $("#user_name").val( displayName );
      $("#user_email").val( userEmail );

      // UPDATE DISPLAYNAME
      $("#user_name").on('keyup', function(event){
        if(this.timer){
          clearTimeout( this.timer );
        }
        if($(".loadingGif").length == 0){
          $(this).after("<img class='loadingGif' src='img/loading.svg' />");
        }
  
        this.timer = setTimeout(function(){
          newName = $("#user_name").val();
          if(newName){
            console.log("Update DisplayName: "+newName);
            firebase.auth().currentUser.updateProfile({
              displayName: newName
            }).then(function(){
              displayName = newName;
              $(".loadingGif").remove();
              $(".usrNameUpdated").remove();
              $("#user_name").after("<p class='usrNameUpdated'>Updated!</p>");
              setTimeout(function(){ $(".usrNameUpdated").remove(); }, 5000);
            });
          }
        }, 1000);
      });
  
      // UPDATE PROFILE PICTURE
      $("#user_photo").one('click', function(){
        photoURL = "https://cdn.libravatar.org/avatar/"+md5( userEmail );
        if(userPhotoURL != photoURL){
          firebase.auth().currentUser.updateProfile({
            photoURL: photoURL
          }).then(function(){
            userPhotoURL = photoURL;
          });
        }
      });

      $("#editUserPhoto").on('click', function(){
        $("#mylibravatarPopup").addClass("show");
        
        $("#mylibravatarPopup div").click(function(e){
          e.stopPropagation();
        });

        $("#mylibravatarPopup, .close").one('click', function(e){
          $("#mylibravatarPopup").removeClass("show");
        });

        if($.inArray("win", $("html").attr("class").split(" ") ) != -1 || $.inArray("android", $("html").attr("class").split(" ") ) != -1){
          $(".close").css({"float": "right", "margin-bottom": "25px" });
        }
      });

      /*/ Pupup for uploading profile pictures, explaning users to use Libravatar.
      function myFunction() {
        var libravatarPopup = document.getElementById("mylibravatarPopup");
        libravatarPopup.classList.toggle("show");
      }

      $("libravatarPopupClose").click(function(event){
        event.preventDefault();
        show();
      });/* */

  
      // GET SETTINGS
      var userSettings = database.ref('users/' + uid);
      userSettings.on('value', function(snapshot){
        console.log("Settings loaded");
        // if( snapshot.hasChild( "settings/plan" ) ){
        // if( typeof snapshot.val().plans[ planNr ] !== "undefined" ){
        if( snapshot.val().plans && snapshot.val().plans[planNr] ){
          // settings = snapshot.val().settings;
          userData = snapshot.val();
          userPlan = userData.plans[ planNr ];
  
          // userData.settings = settings; // UPDATE global settings variable
          // userPlan = settings.plan;
  
          // WEEKDAYS
          weekdays = userData.settings.weekdays.split("");
          $("#weekday div").removeClass("weekdaySelected");
          $.each( weekdays, function( index, value ){
            weekday = value.toString();
            $("#weekday div#"+weekday).addClass("weekdaySelected");
          });
  
          $("#weekday div").unbind();
          $("#weekday div").one('click', function(){
            toggleThis = $( this ).attr('id').toString();
            if( weekdays.indexOf( toggleThis ) >= 0){
              if(weekdays.length > 1){
                key = weekdays.indexOf( toggleThis );
                weekdays.splice( key, 1 );
                newWeekdays = weekdays.join("");
              }
            }
            else {
              weekdays.push( toggleThis );
              newWeekdays = weekdays.join("");
            }
            database.ref('users/' + uid + '/settings').update({ weekdays: newWeekdays });
          });
  
  
  
          // BOOK (what bible) /*REMOVED*/
          // "The Old Testament" and
          // "The New Testament"
  
  
  
          // METHOD
          if( userPlan.method == "daily" ){
            // DAILY CHAPTERS
            $("#methodDaily-wrapper").show();      $("#methodPlan-wrapper").hide();
            $("input.pMethod").val([ "methodDaily" ]);
          }
          else if( userPlan.method == "plan" ){
            // FOLLOWING PLAN
            $("#methodDaily-wrapper").hide();      $("#methodPlan-wrapper").show();
            $("input.pMethod").val([ "methodPlan" ]);
          }
          else if( userPlan.method == "free" ){
            $("#methodDaily-wrapper").hide();      $("#methodPlan-wrapper").hide();
            $("input.pMethod").val([ "methodFree" ]);
          }
  
          // FOLLOWING PLAN
          planStart = new Date( userPlan.start );
          planEnd = new Date( planStart );
          planEnd.setDate(planStart.getDate() + userPlan.length);
          $("#planStart").val( planStart.toISOString().substr(0, 10) ).unbind();  // start day
          $( "#planEnd" ).val( planEnd.toISOString().substr(0, 10) ).unbind();    // end day
          $("#planDynLength").html( translator.get("Plan length")+": "+userPlan.length );
  
          // UPDATE START DATE
          $("#planStart").unbind().on('change', function(){
            var newStart = new Date( $( this ).val() );
            database.ref('users/' + uid + '/plans/'+planNr).update({ start: newStart.getTime(), method: "plan" });
          });
          // UPDATE PLAN LENGTH via end date
          $("#planEnd").unbind().on('change', function(){
            var newEnd = new Date( $( this ).val() );
            var newEnd1 = Number(((newEnd - planStart) / (1000*60*60*24)).toFixed(0));
  
            $("#planDynLength").html( translator.get("Plan length")+": "+ newEnd1 );
  
            if( newEnd1 < 400 && newEnd1 > 0 ){
              database.ref('users/' + uid + '/plans/'+planNr).update({ length: newEnd1, method: "plan" });
              $("#planDynLength").css("color","");
            }
            else {
              $("#planDynLength").css("color","#ff384d");
            }
  
            $("#planLength").html("-"); // RESET HEADLINE
          });
  
  
          // DAILY CHAPTERS
          $("#dailyChapters").val( userPlan.daily ).unbind();
          $("#dailyChapters").on('change', function(){
            newValue = Number( $( this ).val() );
            database.ref('users/' + uid + '/plans/'+planNr).update({ daily: newValue, method: "daily" });
            $("#planLength").html("-"); // RESET HEADLINE
          });
  
  
          // Update method
          $(".pMethod").unbind().on('change', function(){
            if( $("input:checked").val() == "methodDaily" ){
              $("#methodDaily-wrapper").show();  $("#methodPlan-wrapper").hide();
              database.ref('users/' + uid + '/plans/'+planNr).update({ method: "daily" });
            }
            else if( $("input:checked").val() == "methodPlan" ){
              $("#methodDaily-wrapper").hide();  $("#methodPlan-wrapper").show();
              database.ref('users/' + uid + '/plans/'+planNr).update({ method: "plan" });
            }
            else if( $("input:checked").val() == "methodFree" ){
              $("#methodDaily-wrapper").hide();  $("#methodPlan-wrapper").hide();
              database.ref('users/' + uid + '/plans/'+planNr).update({ method: "free" });
            }
            $("#planLength").html("-"); // RESET HEADLINE
          });
  
  
  
          // NOTIFICATION TIME
          notiMinutes = userData.settings.notification;
          if(notiMinutes >= 0){
            $("#notificationTime").attr("disabled",false);
  
            notiHrs = Math.trunc( notiMinutes / 60 );
            notiMins = notiMinutes - ( notiHrs * 60 );
            $("#notificationTime").val( ("0" + notiHrs).slice(-2) + ":" + ("0" + notiMins).slice(-2) ).unbind();
  
            $("#notificationTime").on('change', function(){
              newTime = $( this ).val().split(':');
              newVal = Number(newTime[1]) + ( Number(newTime[0]) * 60);
              database.ref('users/' + uid + '/settings').update({ notification: newVal });
            });
          }
          else {
            $("#notificationTime").val("--:--").attr("disabled",true).unbind();
          }
  
          var notifToggleElem = $("#notificationToggle");
          if( notiMinutes >= 0 ){
            notifToggleElem.unbind().attr('checked',true);
          }
          else {
            notifToggleElem.unbind().attr('checked',false);
          }
  
          notifToggleElem.one('click', function(){
            newTogg = notifToggleElem.is(':checked') ? 12*60 : -1;
            database.ref('users/' + uid + '/settings').update({ notification: newTogg });
  
            console.log("Notifications are now "+newTogg);
          });
  
        }
        else {
          $("#settings").html("<h3 style='margin-top: 50px;'>"+translator.get("Please select a plan before looking at settings!")+"</h3>");
          $("#settingsLetsRead").hide();
        }
      });
  
      $("#changePassword").on("submit", function( event ){
        event.preventDefault();
  
        changePassword( $("#change_pwd_old").val(), $("#change_pwd_new").val(), $("#change_pwd_new1").val() );
      });
    }
    else {
      $("#settings").html("<h3 style='margin-top: 50px;'>"+translator.get("Please select a plan before looking at settings!")+"</h3>");
      $("#settingsLetsRead").hide();

      $("#setupCreateTOS a").on("click",function(event){ event.preventDefault();
        loadPage( $( this ).attr("href"), $( this ).html() );
      });
      
      $("#registerAccount").on('submit',function(event){
        event.preventDefault();
  
        if( $("#acceptTOS").is(":checked") ){
          if(uid){
            var credential = firebase.auth.EmailAuthProvider.credential($("#register_usr_email").val(), $("#register_pwd").val());
            firebase.auth().currentUser.linkAndRetrieveDataWithCredential(credential).then(function(usercred) {
              console.log("User registration/migration complete!");
              var isAnon = false;
              location.reload();
            }, function(error) {
              // throw error message
              console.log("anon upgrade error", error);
              $("#registerErrors").show();
              clearTimeout( regErr );
              $("#registerErrors").html( getErrorMessage( error ) );
              regErr = setTimeout(function() { $("#registerErrors").fadeOut(1000); }, 12500);
            });
          }
          else {
            firebase.auth().createUserWithEmailAndPassword( $("#register_usr_email").val(), $("#register_pwd").val() )
            .then(function(newuser){
              console.log("Register 'blank account' success!", newuser);
              uid = newuser.user.uid;
  
              database.ref('users/' + uid )
                .set({ registered: Date.now(), version: appVersion, lastUse: "-", settings: { language: setLanguage } })
                .then(function(){ location.reload(); });
  
            }, function(error) {
              // throw error message
              console.log("anon upgrade error", error);
              $("#registerErrors").show();
              clearTimeout( regErr );
              $("#registerErrors").html( getErrorMessage( error ) );
              regErr = setTimeout(function() { $("#registerErrors").fadeOut(1000); }, 12500);
            });
          }
        }
        else {
          $("#registerErrors").show();
          clearTimeout( regErr );
          $("#registerErrors").html( translator.get("Please check that you have read and agree to the Terms of Service!") );
          regErr = setTimeout(function() { $("#registerErrors").fadeOut(1000); }, 12500);
        }
  
      });
    }
  
    // CSS-change for android (and windows)
    if($.inArray("safari", $("html").attr("class").split(" ") ) == -1){
      $(".start-date").css({
        "width": "119px",
        "margin-left": "10px",
        "margin-right": "-101px",
        "margin-top": "15px",
        "float": "left"
      });
  
      $(".end-date").css({
        "width": "119px",
        "margin-left": "10px",
        "margin-right": "-101px",
        "margin-top": "15px",
        "float": "left"
      });
  
      if($( window ).width() <= 400){
        $(".start-date").css({
          "margin-left": "-18px",
          "margin-right": "-72px"
        });
  
        $(".end-date").css({
          "margin-left": "-18px",
          "margin-right": "-72px"
        });
      }
    }
  }
  